/*
		Study, a program to write questions and answers and then tests with them.
		Copyright (C) 1997-1998 Josh Cogliati

		This program is free software; you can redistribute it and/or modify
		it under the terms of the GNU General Public License as published by
		the Free Software Foundation; either version 2 of the License, or
		(at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.

		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#define QUESTIONLEN 1024
#define ANSWERLEN 1024
#define HINTLEN 1024
#define RIGHTLEN 1024
#define WRONGLEN 1024
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>
#include <stdio.h>
#include <stdlib.h>
#include <owl\dialog.h>
#include <classlib/arrays.h>
#include <owl\opensave.h>
#include <owl\inputdia.h>
#include <strstrea.h>
#include <owl\edit.h>
#include <owl\button.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\printer.h>
#include <owl\choosefo.h>
#include <cstring.h>
#include "textprnt.h"
#include <string.h>
#include "study.rh"

//List of major classes
//NI=not implemented yet
//NI File_Data class
//This class contains all the data that is saved to disk in one file
//NI Question_Set class
//This class contains all the data and functions to manipulate one question
//set.
//Study_Data class
//This class contains the data for one question.  It also contains the functions for
//testing to see if a answer string is correct and provides a return string.
//studywin class
//This class contains most of the handlers for menu functions.  It also contains a array
//of Study_Data classes.

//Things to remember when programming:

//Lubarsky's Law of Cybernetic Entomology:
//	There's always one more bug.

//Don't Get suckered in by the comments; they can be terribly misleading.  Debug only code.
//					Dave Storer

int argc;//Copy from main(int argc
char argv[256];//Copy of argv[1] for file loading purposes
char AppName[100]="Study Program 1.02";//The name of the program used in caption
HINSTANCE HInstance;//Copy of HInstance used to start program
unsigned int FILE_VERSION=2;//The file version of the file that is currently being saved or loaded
//currently defined file versions 1=file version used with Study 1.0&1.01;2=file
//version with study 1.02&later;3=file version that supports multipule question sets
enum bolstate {AND=1,OR=2,XOR=4,OAND=8};//Used for interpreting answer
//In dialog box AND=All, OR=Some, XOR=Only one, OAND=All in order

//Used to return data about question completion
typedef struct {
	int iscorrect :1;//true if the  question was answer correctly
	int isok:1;//true if OK was pressed in the dialog box
} TQuestionState;//Used to return data from askquestion()

typedef TArray<string> TStringArray;
typedef TArrayIterator<string> TStringArrayIterator;

//Takes string "target" and finds string "find" and repaces find with "replace"
string stringreplace(const string target,const string find,const string replace){
	size_t endkeep,startkeep=0;//startkeep and endkeep surround the string that is not being replaced
	string ret;
	endkeep=target.find(find);
	while(endkeep!=NPOS){
		ret.append(target.substr(startkeep,endkeep-startkeep));
		ret.append(replace);
		startkeep=endkeep+find.length();
		endkeep=target.find(find,startkeep);
	};
	ret.append(target.substr(startkeep));
	return ret;
};

//Same as class library function string::strip, except mine works.
string strip(const string target,string::StripType s = string::Both, char c=' '){
	string ret=target;
	if(!target.is_null()){
	char test;
	if(s==string::Both || s==string::Leading){
		do{
			test=ret[0];
			if(test==c) ret.remove(0,1);
		} while(test==c);
	};
	if(s==string::Both || s==string::Trailing){
		do{
			test=ret[ret.length()-1];
			if(test==c) ret.remove(ret.length()-1);
		} while(test==c);
	};};
	return ret;
};

int mod(int a,int b){
	int ret=a%b;
   if(ret<0) ret+=b;
   return ret;
};

signed long int getfirstint(string* str){
   string temp=strip(*str,string::Leading);
   *str=temp;
   string number;
   size_t firstspace=str->find(" ");
   if(firstspace!=NPOS){
		number=str->substr(0,firstspace);
		temp=(str->substr(firstspace));
		*str=temp;
      return atol(number.c_str());
   };
	return -1;
};

typedef struct {
	string error;//returns message from checkans
	bool iscorrect;//tells if answer given was correct
} Tcheckans;//Used to return data from checkans

//Used to hold one questions data
class Study_Data {
	public:
	string  question;//String containing question, length should be less than QUESTIONLEN
	string  answer;//String containing answer, length should be less than ANSWERLEN
	string  hint;//String containing hint text, length should be less than HINTLEN
   string  rightresponse;//if not is_null() and ccorrect use after a correct answer is given
   string  wrongresponse;//if not is_null() use after a wrong answer
	char  delimit;//delimit is used to seperate multipule answers
	bool  ishint;//true if hint is being used
	bool  ccorrect;//true if additional notice is given about correct answers
	bool  cwhite;//true if whitespace is checked
	bool  cases;//true if case sensitivity is on
	int  boolean;//tells how multipule answers are interpreted.  should be a bolstate enum
	bool  operator ==(const Study_Data& other) const
	{
		return &other == this;
	}
	Tcheckans checkans(string other);//checks a string to see if it is true compared to the answer
	//param:  "string other"  this is compared to answer
	//returns: "Tcheckans ret" tells if answer was correct and returns a error explanation if not
   string get_error_msg(int number_of_answers,string multierror,string singleerror){
   	string error;
      if(wrongresponse.is_null()){
   	if(number_of_answers>1) error=multierror;
		else error=singleerror;
      }
      else
      {
      error=wrongresponse;
      };
      return error;
   };
	Study_Data&  operator = (const Study_Data& other) {
		question=other.question;
		answer=other.answer;
		hint=other.hint;
      rightresponse=other.rightresponse;
      wrongresponse=other.wrongresponse;
		delimit=other.delimit;
		ishint=other.ishint;
		ccorrect=other.ccorrect;
		cwhite=other.cwhite;
		cases=other.cases;
		boolean=other.boolean;
		return *this;
	}
	friend ostream& operator <<(ostream& os, const Study_Data& data4);
	friend ifstream& operator >>(ifstream& is, Study_Data& data4);

};

Tcheckans Study_Data::checkans(string other){
		bool retval=FALSE,inorder=TRUE;
		//string::StripType s=string::Both;
		string error="";
		char answ[ANSWERLEN]="";
		char input[ANSWERLEN]="";
		char delim[2]="";
		TStringArray ans(0,0,10);
		TStringArray inut(0,0,10);
		string temp;
		short int check[256]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		short int numcorrect=0;
		short int checksum=0;
		short int numinanswer=0;
		short int numinputed=0;
		delim[0]=delimit;
		delim[1]=0;
		strcpy(answ,answer.c_str());
		strcpy(input,other.c_str());
		temp=string(strtok(answ,delim));
		temp.set_case_sensitive(cases);
		if(!cwhite)
			temp=strip(temp);
		ans.Add(temp);
		while(!((ans[numinanswer]).is_null())){
			numinanswer++;
			temp=string(strtok(NULL, delim));
			temp.set_case_sensitive(cases);
			if(!cwhite)
				temp=strip(temp);
			ans.Add(temp);
		};
		numinanswer--;
		temp=string(strtok(input,delim));
		temp.set_case_sensitive(cases);
		if(!cwhite)
			temp=strip(temp);
		inut.Add(temp);
		while(!((inut[numinputed]).is_null())){
			numinputed++;
			temp=string(strtok(NULL,delim));
			temp.set_case_sensitive(cases);
			if(!cwhite)
				temp=strip(temp);
			inut.Add(temp);
		};
		numinputed--;
		for(int i=0;i<=numinputed;i++){
			check[i]=0;
			for(int i2=0;i2<=numinanswer;i2++){
					if(inut[i]==ans[i2]){
					numcorrect++;check[i]=i2;checksum=checksum+i;
					}
			};
		};
		if(numinanswer!=numinputed){inorder=FALSE;} else {
		for(int i=0;i<=numinputed;i++){
					if(inut[i]!=ans[i]){
					inorder=FALSE;
					}
		};};
		if(numcorrect<1) {retval=FALSE;}
		if(boolean==OR){
			if(numcorrect-1==numinputed && numcorrect>=1) {retval=TRUE;} else
			{
			retval=FALSE;
			error=get_error_msg(numinanswer,string(HInstance,IDS_WRONGOR),string(HInstance,IDS_WRONGANS));
			}
		};
		if(boolean==XOR){
			if((numcorrect==1)&&(numinputed==0)) {retval=TRUE;} else
			{
			retval=FALSE;
			error=get_error_msg(numinanswer,string(HInstance,IDS_WRONGXOR),string(HInstance,IDS_WRONGANS));
			}
		};
		if(boolean==AND){
			if((numcorrect-1==numinanswer)&&(checksum==((numinanswer+1)*numinanswer/2))) {retval=TRUE;} else
				{
				retval=FALSE;
				error=get_error_msg(numinanswer,string(HInstance,IDS_WRONGAND),string(HInstance,IDS_WRONGANS));
				}
		};
		if(boolean==OAND){
			if((numcorrect-1==numinanswer)&&(checksum==((numinanswer+1)*numinanswer/2)) && inorder==TRUE) {
				retval=TRUE;
				} else
				{
				retval=FALSE;
				error=get_error_msg(numinanswer,string(HInstance,IDS_WRONGOAND),string(HInstance,IDS_WRONGANS));
				}
		};
		Tcheckans ret;
		error=stringreplace(error,string("<<CORRECT>>"),answer);
      error=stringreplace(error,string("<<QUESTION>>"),question);
      error=stringreplace(error,string("<<INPUT>>"),other);
		ret.error=error;
		ret.iscorrect=retval;
		return (ret);
};

typedef  TArray<Study_Data> dat;
typedef  TArrayIterator<Study_Data> datint;

class Question_Set{
  	public:
		Question_Set();
      ~Question_Set();
      Add(Study_Data sd){
      	qdt->Add(sd);
      };
      AddAt(Study_Data sd,unsigned int loc){
      	qdt->AddAt(sd,loc);
      };
      unsigned int Size(){
      	return qdt->GetItemsInContainer();
      };
      Delete(unsigned int loc){
      	qdt->Detach(loc);
      };
  	protected:
   	string name;
		dat* qdt;//Contains a array of the questions (Question DaTa)
};

Question_Set::Question_Set(){
	qdt	=new  dat(50,1,1);
};

Question_Set::~Question_Set(){
	delete qdt;
};

struct editdialtrans {//used to transfer info to and from editdialog
	char edit3[QUESTIONLEN];
	char edit2[ANSWERLEN];
	char hint[HINTLEN];
   char right[RIGHTLEN];
   char wrong[WRONGLEN];
	char delimit;
	uint16 ishint;
	uint16 ccorrect;
	uint16 cases;
	uint16 cwhite;
	uint16 boolean;
} dt;

struct testdialtrans {//used to transfer info to and from testdial
	char edit1[ANSWERLEN];
	char question[QUESTIONLEN];
	char hint[HINTLEN];
	bool ishint;
} dt2;

struct advancedialtrans {//used to transfer info to and from advancedialog
	char hint[HINTLEN];
   char right[RIGHTLEN];
   char wrong[WRONGLEN];
	char delimit[2];
	uint16 ishint;
	uint16 ccorrect;
	uint16 cases;
	uint16 cwhite;
	uint16 and;
	uint16 or;
	uint16 xor;
	uint16 oand;
} dt3;

struct printtrans {//used to transfer info to and from printdialog
	uint16 question;
	uint16 answer;
	uint16 hint;
	uint16 delimit;
	uint16 ishint;
	uint16 ccorrect;
	uint16 cases;
	uint16 boolean;
   uint16 cwhite;
} pt;

//Intermediate dialog to allow charmapwin functionality to any dialog
class STDialog: public TDialog {
	public:
	STDialog(TWindow* parent,TResId resId):TDialog(parent,resId),TWindow(parent){};
	virtual void HandleChar(char){};
};

//Dialog used for advanced options
class advancedialog: public TDialog
{
	public:
		advancedialog(TWindow* parent,TResId resId,HFONT font=NULL):TDialog(parent,resId),TWindow(parent){
      SetWindowFont(font, true);
		TEdit* edit;
		edit = new TEdit(this,IDC_EDIT7, HINTLEN);
		edit->EnableTransfer();
		edit = new TEdit(this,IDC_EDIT8, RIGHTLEN);
		edit->EnableTransfer();
		edit = new TEdit(this,IDC_EDIT9, WRONGLEN);
		edit->EnableTransfer();
		edit = new TEdit(this,IDC_EDIT5,2);
		edit->EnableTransfer();
		TCheckBox* check;
		check = new TCheckBox(this,IDC_CHECKBOX1);
		check = new TCheckBox(this,IDC_CHECKBOX2);
		check = new TCheckBox(this,IDC_CHECKBOX3);
		check = new TCheckBox(this,IDC_CHECKBOX4);
		TRadioButton* radio;
		radio = new TRadioButton(this,RAND);
		radio = new TRadioButton(this,ROR);
		radio = new TRadioButton(this,RXOR);
		radio = new TRadioButton(this,ROAND);
		SetTransferBuffer(&dt3);
	};
};

const int CHARACROSS=16,CHARUP=14;
//Class to Display all the characters and return a code to a ANSII code
class charmapwindow: public TDialog{
	public:
	int maxwidth,maxheight;
   int curx,cury;
   HFONT font;
   //void (*sendchar)(char);
   //HWND Hparent;
	charmapwindow::charmapwindow(TWindow* parent, HFONT usefont=NULL):TDialog(parent,CHARMAP),TWindow(parent){
   font=usefont;
	//sendchar=&(that->handlechar);
   //Hparent=parent->HWindow;
   };
   void SetupWindow(){
   	TDialog::SetupWindow();
   	TFont tfont(font);
	   maxwidth=tfont.GetMaxWidth();
	   maxheight=tfont.GetHeight();
      curx=0;cury=0;
      TRect rect;
      GetWindowRect(rect);
	   MoveWindow(rect.X(),rect.Y(),3+CHARACROSS*(maxwidth+3)+2*GetSystemMetrics(SM_CXDLGFRAME),3+CHARUP*(maxheight+3)+GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYDLGFRAME)+3);
   };
   void DrawChar(int x,int y,TDC &dc,bool isselected=false){
		char drawstring[2]=" ";
		TPoint topleft,recttl;
	   topleft.x=3+x*(3+maxwidth);
     	topleft.y=3+y*(3+maxheight);
      TSize textsize=TSize(maxwidth,maxheight);
      TSize rectsize=TSize(maxwidth+4,maxheight+4);
	   drawstring[0]=32+x+y*CHARACROSS;
      dc.LPtoDP(&topleft);//NOte: probably useless
		recttl.x=topleft.x-2;
      recttl.y=topleft.y-2;
      if(isselected){
         dc.SelectStockObject(BLACK_BRUSH);
         dc.SelectStockObject(WHITE_PEN);
         dc.SetBkColor(TColor::Black);
         dc.SetTextColor(TColor::White);
     	};
      dc.Rectangle(recttl,rectsize);
      TRect rect=TRect(topleft,textsize);
 		dc.DrawText(drawstring,-1, rect,DT_CENTER);
      if(isselected){
         dc.SelectStockObject(WHITE_BRUSH);
         dc.SelectStockObject(BLACK_PEN);
         dc.SetBkColor(TColor::White);
         dc.SetTextColor(TColor::Black);

     	};
   };
   void EvPaint(){
   	DefaultProcessing();
   	//TDC& dc, bool erase, TRect& rect
      char drawstring[2]=" ";
      //TPoint topleft,recttl;
     	TClientDC dc(this->HWindow);
     	//TRect rect=GetClientRect();
      dc.SelectObject(TFont(font));
      dc.SelectStockObject(WHITE_BRUSH);
      dc.SelectStockObject(BLACK_PEN);
      //dc.Rectangle(rect);
      //dc.SetTextAlign(TA_TOP|TA_LEFT|TA_NOUPDATECP);
      for(int y=0;y<CHARUP;y++){
			for(int x=0;x<CHARACROSS;x++){
            DrawChar(x,y,dc);
    };
      };
   };
	void EvKeyDown(uint key, uint /*repeatCount*/, uint /*flags*/){
   	DefaultProcessing();
     	TClientDC dc(this->HWindow);
      dc.SelectStockObject(WHITE_BRUSH);
      dc.SelectStockObject(BLACK_PEN);
      dc.SelectObject(TFont(font));
      DrawChar(curx,cury,dc);
      switch (key) {
      	case VK_LEFT:
				curx--;
            curx=mod(curx,CHARACROSS);
         	break;
         case VK_RIGHT:
				curx++;
            curx=mod(curx,CHARACROSS);
				break;
			case VK_UP:
				cury--;
            cury=mod(cury,CHARUP);
            break;
         case VK_DOWN:
				cury++;
            cury=mod(cury,CHARUP);
				break;
         case VK_SPACE:
            //::PostMessage(Hparent,WM_CHAR,(WPARAM)(32+curx+cury*CHARACROSS),(LPARAM)(0));
				{STDialog* parent=TYPESAFE_DOWNCAST(GetParentO(),STDialog);
 				//parent->PostMessage(WM_CHAR,(WPARAM)(32+curx+cury*CHARACROSS),(LPARAM)(0));
            parent->HandleChar(32+curx+cury*CHARACROSS);
            }
         	break;
         case VK_RETURN:
				{STDialog* parent=TYPESAFE_DOWNCAST(GetParentO(),STDialog);
            parent->HandleChar(32+curx+cury*CHARACROSS);
            }
            CloseWindow();
         	break;
         default:
            break;
         };
      DrawChar(curx,cury,dc,true);
   };
   //Changes curx,cury to point given
   char PointtoChar(TPoint &point){
      curx=point.x/(maxwidth+3);
      cury=point.y/(maxheight+3);
      return (char)(32+curx+cury*CHARACROSS);
   };
   void EvRButtonDown(uint /*modKeys*/, TPoint& point){
      char ret=PointtoChar(point);
		{STDialog* parent=TYPESAFE_DOWNCAST(GetParentO(),STDialog);
      parent->HandleChar(32+curx+cury*CHARACROSS);
      }
		CloseWindow();
   };
   void EvLButtonDown(uint /*modKeys*/, TPoint& point){
   	DefaultProcessing();
     	TClientDC dc(this->HWindow);
      dc.SelectStockObject(WHITE_BRUSH);
      dc.SelectStockObject(BLACK_PEN);
      dc.SelectObject(TFont(font));
      DrawChar(curx,cury,dc);
      char ret=PointtoChar(point);
		{STDialog* parent=TYPESAFE_DOWNCAST(GetParentO(),STDialog);
      parent->HandleChar(32+curx+cury*CHARACROSS);
      }
      DrawChar(curx,cury,dc,true);
   };
   DECLARE_RESPONSE_TABLE(charmapwindow);
};


DEFINE_RESPONSE_TABLE1(charmapwindow,TDialog)
	EV_WM_PAINT,
   EV_WM_KEYDOWN,
   EV_WM_RBUTTONDOWN,
   EV_WM_LBUTTONDOWN,
END_RESPONSE_TABLE;

//Dialog for normal editing of questions
class editdialog :public STDialog
{
	public:
		editdialog(TWindow* parent,TResId resId,int cur,bool isnew,HFONT usefont);
      ~editdialog(){
      	delete question;
         delete answer;
         delete cmwin;
      };
      //void handlechar(char ch){};
	   //void (*getchar)(char);
      void SetupWindow();
      void HandleChar(char ch);
      int cur2;
      HFONT font;
      TEdit* question;
      TEdit* answer;
      THandle focus;
      charmapwindow* cmwin;
		void HandlePButtonMsg();
		void HandleNButtonMsg();
		void HandleDButtonMsg();
		void HandleAButtonMsg();
		void HandleIButtonMsg();
		void HandleMButtonMsg();
		void HandleHButtonMsg();
		void HandleEButtonMsg();
      void CmCharMap();
		DECLARE_RESPONSE_TABLE(editdialog);
};

editdialog::editdialog(TWindow* parent,TResId resId,int cur,bool isnew=true, HFONT usefont=NULL):STDialog(parent,resId),TWindow(parent){
		font=usefont;
      //getchar=&(this->handlechar);
      //getchar=&bogus;
      cmwin=new charmapwindow(this,font);
		char cap[70];
		char temps[20];
		cur2=cur;
		itoa(cur,temps,10);
		strcpy(cap,string(HInstance,IDS_QUESTEDIT).c_str());
		strcat(cap,temps);
		if(isnew) strcat(cap,string(HInstance,IDS_QUESTEDITNEW).c_str());
		SetCaption(cap);
		//TEdit* edit;
		question = new TEdit(this,IDC_EDIT2,QUESTIONLEN);
		question->EnableTransfer();
		answer = new TEdit(this,IDC_EDIT3, ANSWERLEN);
		answer->EnableTransfer();
		new TButton(this, PREVB, FALSE);
		new TButton(this, NEXTB, FALSE);
		new TButton(this, DELB,FALSE);
		//new TButton(this, ADVAB,FALSE);
		//new TButton(this, CM_INSERT,FALSE);
		//new TButton(this, MOVEB, FALSE);
		//new TButton(this, HOMEB, FALSE);
		//new TButton(this, ENDB, FALSE);
		SetTransferBuffer(&dt);
}

void editdialog::SetupWindow(){
  	TDialog::SetupWindow();
	question->SetWindowFont(font,true);
   answer->SetWindowFont(font,true);
};

void editdialog::HandleChar(char ch){
	char replace[2]=" ";
   int CtrlID=::GetDlgCtrlID(focus);
   replace[0]=ch;
	if(question->GetDlgCtrlID()==CtrlID)
   	question->Insert(replace);
   if(answer->GetDlgCtrlID()==CtrlID)
   	answer->Insert(replace);
   /*::PostMessage(focus,EM_REPLACESEL,(WPARAM)false,(LPARAM)replace);
	if(debug==NULL){
    	MessageBox("Didn't work","Title",MB_OK);
   }; */
   /*string pattern(ch);
  	TClipboard c(*this);
  	c.EmptyClipboard();
  	HANDLE hData = ::GlobalAlloc(GMEM_SHARE, pattern.length()+1);
  	char far* pData = (char far*)::GlobalLock(hData);
  	pattern.copy(pData, pattern.length()+1);
  	::GlobalUnlock(hData);
  	c.SetClipboardData(CF_TEXT, hData);
   THandle handle=SetActiveWindow();
	SendMessage(WM_PASTE);
   ::SetActiveWindow(handle);*/
	/*uint a,b,c;
	question->GetSelection(a,b);
   c=a+b;
   answer->GetSelection(a,b);
   c=a+b+c;
   c++;*/
};

DEFINE_RESPONSE_TABLE1(editdialog,TDialog)
	EV_COMMAND(PREVB, HandlePButtonMsg),
   EV_COMMAND(CM_PREV,HandlePButtonMsg),
	EV_COMMAND(NEXTB, HandleNButtonMsg),
   EV_COMMAND(CM_NEXT,HandleNButtonMsg),
	EV_COMMAND(DELB,HandleDButtonMsg),
   EV_COMMAND(CM_DELETE,HandleDButtonMsg),
	EV_COMMAND(CM_ADVA,HandleAButtonMsg),
	EV_COMMAND(CM_INSERT,HandleIButtonMsg),
	EV_COMMAND(CM_MOVE,HandleMButtonMsg),
	EV_COMMAND(CM_HOME,HandleHButtonMsg),
	EV_COMMAND(CM_END,HandleEButtonMsg),
   EV_COMMAND(CM_CHARMAP,CmCharMap),
END_RESPONSE_TABLE;

//Prev Button handler
void editdialog::HandlePButtonMsg(){
	if(cur2!=1){
	TransferData(tdGetData);
	editdialog::Destroy(PREVB);}
	else{
	MessageBeep(MB_ICONASTERISK);};
};
//Next Button handler
void editdialog::HandleNButtonMsg(){
	TransferData(tdGetData);
	editdialog::Destroy(NEXTB);
};
//Delete Button handler
void editdialog::HandleDButtonMsg(){
	editdialog::Destroy(DELB);
};
//Advanced Button handler
void editdialog::HandleAButtonMsg(){
	strncpy(dt3.hint,dt.hint,HINTLEN);
   strncpy(dt3.right,dt.right,RIGHTLEN);
   strncpy(dt3.wrong,dt.wrong,WRONGLEN);
	dt3.ishint=dt.ishint;
	dt3.ccorrect=dt.ccorrect;
	dt3.cases=dt.cases;
	dt3.cwhite=dt.cwhite;
	dt3.delimit[0]=dt.delimit;
   dt3.delimit[1]='\0';
	if (dt.boolean==AND) dt3.and=BF_CHECKED*256; else dt3.and=BF_UNCHECKED;
	if (dt.boolean==OR) dt3.or=BF_CHECKED*256; else dt3.or=BF_UNCHECKED;
	if (dt.boolean==XOR) dt3.xor=BF_CHECKED*256; else dt3.xor=BF_UNCHECKED;
	if (dt.boolean==OAND) dt3.oand=BF_CHECKED*256; else dt3.oand=BF_UNCHECKED;
	if((advancedialog(this,ADVANCE,font).Execute())==IDOK){
	strncpy(dt.hint,dt3.hint,HINTLEN);
   strncpy(dt.right,dt3.right,RIGHTLEN);
   strncpy(dt.wrong,dt3.wrong,WRONGLEN);
	dt.ishint=dt3.ishint;
	dt.ccorrect=dt3.ccorrect;
	dt.cases=dt3.cases;
	dt.cwhite=dt3.cwhite;
	dt.delimit=dt3.delimit[0];
	if (dt3.and) dt.boolean=AND;
	if (dt3.or) dt.boolean=OR;
	if (dt3.xor) dt.boolean=XOR;
	if (dt3.oand) dt.boolean=OAND;
	};
};
//Insert Button handler
void editdialog::HandleIButtonMsg(){
	TransferData(tdGetData);
	editdialog::Destroy(CM_INSERT);
};
//Move Button handler
void editdialog::HandleMButtonMsg(){
	TransferData(tdGetData);
	editdialog::Destroy(CM_MOVE);
};
//Home Button handler
void editdialog::HandleHButtonMsg(){
	TransferData(tdGetData);
	editdialog::Destroy(CM_HOME);
};
//End Button handler
void editdialog::HandleEButtonMsg(){
	TransferData(tdGetData);
	editdialog::Destroy(CM_END);
};

void editdialog::CmCharMap(){
	if(cmwin->IsWindow()){
   	cmwin->Destroy();
   }	else {
      focus=GetFocus();
		cmwin->Create();
   };
};

//Dialog for asking questions
class testdial :public TDialog
	{
		public:
			TStatic* statik;
         TEdit* answer;
         HFONT font;
			testdial(TWindow* parent,TResId resId, HFONT usefont=NULL):TDialog(parent,resId),TWindow(parent){
			font=usefont;
			//SetWindowFont(font,true);
			//TEdit* edit;
			answer = new TEdit(this,IDC_EDIT1, ANSWERLEN);
			answer->EnableTransfer();
         answer->SetWindowFont(font,true);
			statik=new TStatic(this,IDSTAT,QUESTIONLEN);
         statik->SetWindowFont(font,true);
			new TButton(this, HINTB,FALSE);
			SetTransferBuffer(&dt2);
			};
			void testdial::SetupWindow() {
			TDialog::SetupWindow();
			statik->SetText(dt2.question);
		   statik->SetWindowFont(font,true);
		   answer->SetWindowFont(font,true);
			};
			~testdial(){
			delete statik;
         delete answer;
			};

			void HandleHButtonMsg();
			DECLARE_RESPONSE_TABLE(testdial);
};

DEFINE_RESPONSE_TABLE1(testdial,TDialog)
	EV_COMMAND(HINTB, HandleHButtonMsg),
END_RESPONSE_TABLE;

//Hint Button handler
void testdial::HandleHButtonMsg(){
	MessageBox(dt2.hint,string(HInstance,IDS_HINT).c_str(),MB_OK);
	Invalidate();
};

//Dialog for selecting print options
class printdial:public TDialog{
	public:
		//printdial(TWindow* parent,TResId resId,TTextPrinter *tpp):TDialog(parent,resId),TWindow(parent){
		printdial(TWindow* parent,TResId resId):TDialog(parent,resId),TWindow(parent){
/*		//TCheckBox* check;
		check = new TCheckBox(this,IDC_CHECKBOX5);
		check = new TCheckBox(this,IDC_CHECKBOX6);
		check = new TCheckBox(this,IDC_CHECKBOX7);
		check = new TCheckBox(this,IDC_CHECKBOX8);
		check = new TCheckBox(this,IDC_CHECKBOX9);
		check = new TCheckBox(this,IDC_CHECKBOX10);
		check = new TCheckBox(this,IDC_CHECKBOX11);
		check = new TCheckBox(this,IDC_CHECKBOX12);
      check = new TCheckBox(this,IDC_CHECKBOX13);*/
		check5=new TCheckBox(this,IDC_CHECKBOX5);
		check6=new TCheckBox(this,IDC_CHECKBOX6);
		check7=new TCheckBox(this,IDC_CHECKBOX7);
		check8=new TCheckBox(this,IDC_CHECKBOX8);
		check9=new TCheckBox(this,IDC_CHECKBOX9);
		check10=new TCheckBox(this,IDC_CHECKBOX10);
		check11=new TCheckBox(this,IDC_CHECKBOX11);
		check12=new TCheckBox(this,IDC_CHECKBOX12);
      check13=new TCheckBox(this,IDC_CHECKBOX13);
		new TButton(this, SETUPB,FALSE);
		SetTransferBuffer(&pt);
		//tp=tpp;
		};
      ~printdial(){
      delete check5;
      delete check6;
      delete check7;
      delete check8;
      delete check9;
      delete check10;
      delete check11;
      delete check12;
      delete check13;
      };
		TCheckBox *check5;
		TCheckBox *check6;
		TCheckBox *check7;
		TCheckBox *check8;
		TCheckBox *check9;
		TCheckBox *check10;
		TCheckBox *check11;
		TCheckBox *check12;
		TCheckBox *check13;
  		//TTextPrinter *tp;
		void HandleSButtonMsg();
		//DECLARE_RESPONSE_TABLE(printdial);
};
/*
DEFINE_RESPONSE_TABLE1(printdial,TDialog)
	//EV_COMMAND(SETUPB, HandleSButtonMsg),
END_RESPONSE_TABLE;*/

//Setup Button handler THIS FEATURE DOES NOT EXIST
void printdial::HandleSButtonMsg(){
	//tp->Setup(HWindow);
};

//This window contains all program data and contains most funtions and handlers for menu functions
class studywin: public TWindow {
	public:
		studywin(TWindow* parent = 0);
		~studywin();
		void Paint(TDC&, bool, TRect&)
		{};
		//Menu handlers
		void CmFileNew();
		void CmToolsEdit();
		void CmFileOpen();
		void CmFileSave();
		void CmFileSaveAs();
      void CmFileExport();
		void CmFilePrint();
		void CmFilePrintSetup();
		void CmAbout();
		void CmToolsQuiz();
		void CmToolsTest();
		void CmHelp();
		void CmReverseQA();
      void CmFont();
		void SaveFile();//saves file to file name in FileData
		void OpenFile();//opens file with file name in FileData
		void setcap();//Sets the caption to current filename and the program name
		TQuestionState askquestion(Study_Data sd);//Does most of the work for asking a question
		bool CanClose();//checks to see if the window can be closed
		bool IsNewFile;//true if there is no file name
		bool IsDirty;//true if the questions have been modified
		bool IsReverseQA;//true if the questions and answers should be reversed in a "Jeopardy" way
      bool IsFontModified;//true if dialogfont is not the default, so save with file
	protected:
		dat* qdt;//Contains a array of the questions
		TOpenSaveDialog::TData* FileData;//contains file name and file filters
		char extname[256],ext[128];
      TFont * dialogfont;
		DECLARE_RESPONSE_TABLE(studywin);
};
DEFINE_RESPONSE_TABLE1(studywin, TWindow)
	EV_COMMAND(CM_FILENEW, CmFileNew),
	EV_COMMAND(CM_TOOLSEDIT, CmToolsEdit),
	EV_COMMAND(CM_FILEOPEN, CmFileOpen),
	EV_COMMAND(CM_FILESAVE, CmFileSave),
	EV_COMMAND(CM_FILESAVEAS, CmFileSaveAs),
   EV_COMMAND(CM_FILEEXPORT, CmFileExport),
	EV_COMMAND(CM_FILEPRINT,CmFilePrint),
	//EV_COMMAND(CM_FILEPRINTER_SETUP1, CmFilePrintSetup),
	EV_COMMAND(CM_HELPABOUT, CmAbout),
	EV_COMMAND(CM_TOOLSTEST, CmToolsTest),
	EV_COMMAND(CM_TOOLSQUIZ,CmToolsQuiz),
	EV_COMMAND(CM_HELPCONTENTS,CmHelp),
	EV_COMMAND(CM_TOOLSREVERSE_QA,CmReverseQA),
   EV_COMMAND(CM_TOOLSFONT,CmFont),
END_RESPONSE_TABLE;

studywin::studywin(TWindow* parent)
{
	Init(parent,0,0);
	qdt	=new  dat(50,1,1);
	//printer = new TPrinter;
	IsNewFile = true;
	IsDirty = false;
	IsReverseQA=false;
   IsFontModified=false;
   dialogfont=new TFont("Arial");
	strcpy(extname,string(HInstance,IDS_EXTNAME).c_str());
	strcpy(ext,string(HInstance,IDS_EXT).c_str());
	FileData  = new TOpenSaveDialog::TData(OFN_HIDEREADONLY|OFN_FILEMUSTEXIST|OFN_OVERWRITEPROMPT,
													 extname, 0, "",ext
													 );
	FileData->FilterIndex=FILE_VERSION;
	if(argc>1) {strcpy(FileData->FileName, argv);
	OpenFile();
	};
}
studywin::~studywin()
{
	delete qdt;
	delete FileData;
   delete dialogfont;
	//delete printer;
};
void studywin::CmToolsEdit(){
	Study_Data data3;
	unsigned int i=qdt->GetItemsInContainer();
	int state=IDOK;
	unsigned int cur=i;

	top:
	if (cur==0) cur++;
	i=qdt->GetItemsInContainer();
	if(cur<=i && state!=CM_INSERT){
		data3=(*qdt)[cur];
		strncpy(dt.edit3,data3.question.c_str(),QUESTIONLEN);
		strncpy(dt.edit2,data3.answer.c_str(),ANSWERLEN);
		strncpy(dt.hint,data3.hint.c_str(),HINTLEN);
      strncpy(dt.right,data3.rightresponse.c_str(),RIGHTLEN);
      strncpy(dt.wrong,data3.wrongresponse.c_str(),WRONGLEN);
		dt.delimit=data3.delimit;
		dt.ishint=data3.ishint;
		dt.ccorrect=data3.ccorrect;
		dt.cases=data3.cases;
		dt.cwhite=data3.cwhite;
		dt.boolean=data3.boolean;
		}
	else
		{
		strncpy(dt.edit3,"",QUESTIONLEN);
		strncpy(dt.edit2,"",ANSWERLEN);
		strncpy(dt.hint,"",HINTLEN);
		if(cur==1){ dt.delimit=',';dt.boolean=AND;dt.cases=FALSE;dt.ishint=FALSE;}
		};
	state=editdialog(this,EDIT,cur,cur>i,dialogfont->GetHandle()).Execute();
	if(!((state)==IDCANCEL)){
		IsDirty = true;
		data3.question=string(dt.edit3);
		data3.answer=string(dt.edit2);
		data3.hint=string(dt.hint);
      data3.wrongresponse=string(dt.wrong);
      data3.rightresponse=string(dt.right);
		data3.delimit=dt.delimit;
		data3.ishint=dt.ishint;
		data3.ccorrect=dt.ccorrect;
		data3.cases=dt.cases;
		data3.cwhite=dt.cwhite;
		data3.boolean=dt.boolean;
	if(cur>i){
		qdt->Add(data3);}
	else
		{
		qdt->Detach(cur);
		qdt->AddAt(data3,cur);
		};
	};
	if((state==PREVB) && (cur>qdt->LowerBound())){
	cur--;goto top;
	};
	if(state==NEXTB){
	cur++;
	goto top;
	};
	if((state==DELB) && (cur>=qdt->LowerBound())){
	qdt->Detach(cur);
	if(cur>=qdt->GetItemsInContainer()) cur--;
	goto top;
	};
	if((state==CM_INSERT) && (cur<=qdt->UpperBound())){
	qdt->AddAt(data3,cur+1);
	goto top;
	};
	if(state==CM_HOME){
	cur=qdt->LowerBound();
	goto top;
	};
	if(state==CM_END){
	cur=qdt->GetItemsInContainer();
	goto top;
	};
	if(state==CM_MOVE){
	char num[64]="";
	int mbstate,ncur;
	qdt->Detach(cur);
	//qdt->AddAt(data3,cur);
	mbstate=TInputDialog(this,string(HInstance,IDS_MOVE).c_str(),string(HInstance,IDS_MOVEQUEST).c_str(),num,64).Execute();
	if(mbstate==IDOK){
			ncur=atoi(num);
			if(ncur<=qdt->UpperBound()){
				qdt->AddAt(data3,ncur);
				cur=ncur;
			}
			else {
			qdt->Add(data3);
			};} else {
		qdt->AddAt(data3,cur);
		};
	goto top;
	};

};

void studywin::CmFileOpen(){
	 if(CanClose()){
	 if ((TFileOpenDialog(this, *FileData)).Execute() == IDOK)
		OpenFile();
		setcap();
	 };
};
void studywin::CmFileNew(){
	if(CanClose()){
	qdt->Flush();
	IsNewFile = true;
	IsDirty = false;
	setcap();
	CmToolsEdit();};
};
void studywin::CmFileSave(){
	if (IsNewFile)
	 CmFileSaveAs();
	else
	 SaveFile();
};
void studywin::CmFileSaveAs(){
	if (IsNewFile)
	 strcpy(FileData->FileName, "");

	if ((TFileSaveDialog(this, *FileData)).Execute() == IDOK)
	 SaveFile();
	setcap();

};
void studywin::CmFileExport(){
	int state=printdial(this,PRINT).Execute();
	if(state==IDOK){
		SetCursor(0,IDC_WAIT);
		char buf[QUESTIONLEN+ANSWERLEN+HINTLEN+RIGHTLEN+WRONGLEN+1024]="";
      TOpenSaveDialog::TData data
			(OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
			"Text Files (*.TXT)|*.txt|",
			0,
			"",
			"TXT");
		if (TFileSaveDialog(this, data).Execute() == IDOK) {
		// save data to file
		ofstream os(data.FileName);
		if (!os)
			MessageBox(string(HInstance,IDS_CANTSAVE).c_str(), string(HInstance,IDS_FILEERROR).c_str(), MB_OK | MB_ICONEXCLAMATION);
		else {
      int c=0;
		datint i(*qdt);
		while(i){
			Study_Data td=i++;
			c++;
				strcpy(buf,"");
				ostrstream str(buf,sizeof buf );
				str<<string(HInstance,IDS_QUEST)<<c<<'\n';
				if(pt.question) str<<td.question <<'\n';
				if(pt.answer) str<<td.answer<<'\n';
				if(pt.hint) str<<td.hint<<'\n';
				if(pt.delimit) str<<td.delimit<<'\n';
				if(pt.ishint){if(td.ishint) str<<string(HInstance,IDS_ISHINT)<<'\n'; else str<<string(HInstance,IDS_NOTHINT)<<'\n';};
				if(pt.ccorrect){if(td.ccorrect) str<<string(HInstance,IDS_CCORRECT)<<'\n'; else str<<string(HInstance,IDS_NCCORRECT)<<'\n';};
				if(pt.cases){if(td.cases) str<<string(HInstance,IDS_CASES)<<'\n'; else str<<string(HInstance,IDS_NCASES)<<'\n';};
				if(pt.boolean){if(td.boolean==AND) str<<string(HInstance,IDS_AND)<<'\n';if(td.boolean==OR) str<<string(HInstance,IDS_OR)<<'\n';if(td.boolean==XOR) str<<string(HInstance,IDS_XOR)<<'\n';if(td.boolean==OAND) str<<string(HInstance,IDS_OAND)<<'\n';};
				if(pt.cwhite){if(td.cwhite) str<<string(HInstance,IDS_CWHITE)<<'\n';else str<<string(HInstance,IDS_NCWHITE)<<'\n';};
				str<<ends;
				os<<buf;

		};};};
		SetCursor(0,IDC_ARROW);
	};
};
void studywin::CmFilePrint(){
	int state=printdial(this,PRINT).Execute();
	if(state==IDOK){
		SetCursor(0,IDC_WAIT);
		char buf[QUESTIONLEN+ANSWERLEN+HINTLEN+RIGHTLEN+WRONGLEN+1024]="";
		TTextPrinter tp;
		int c=0;
		datint i(*qdt);
		while(i){
			Study_Data td=i++;
			c++;
				strcpy(buf,"");
				ostrstream str(buf,sizeof buf );
				str<<string(HInstance,IDS_QUEST)<<c<<'\n';
				if(pt.question) str<<td.question <<'\n';
				if(pt.answer) str<<td.answer<<'\n';
				if(pt.hint) str<<td.hint<<'\n';
				if(pt.delimit) str<<td.delimit<<'\n';
				if(pt.ishint){if(td.ishint) str<<string(HInstance,IDS_ISHINT)<<'\n'; else str<<string(HInstance,IDS_NOTHINT)<<'\n';};
				if(pt.ccorrect){if(td.ccorrect) str<<string(HInstance,IDS_CCORRECT)<<'\n'; else str<<string(HInstance,IDS_NCCORRECT)<<'\n';};
				if(pt.cases){if(td.cases) str<<string(HInstance,IDS_CASES)<<'\n'; else str<<string(HInstance,IDS_NCASES)<<'\n';};
				if(pt.boolean){if(td.boolean==AND) str<<string(HInstance,IDS_AND)<<'\n';if(td.boolean==OR) str<<string(HInstance,IDS_OR)<<'\n';if(td.boolean==XOR) str<<string(HInstance,IDS_XOR)<<'\n';if(td.boolean==OAND) str<<string(HInstance,IDS_OAND)<<'\n';};
				if(pt.cwhite){if(td.cwhite) str<<string(HInstance,IDS_CWHITE)<<'\n';else str<<string(HInstance,IDS_NCWHITE)<<'\n';};
				str<<ends;
				tp<<buf;

		};
		SetCursor(0,IDC_ARROW);
	};
	//delete tp;
};
void studywin::CmFilePrintSetup(){
	//printer->Setup(this);
	//tp->Setup();
	//MessageBox("Printing uses default printer regadless of printer selected, Sorry.","Beta Version",MB_OK);
};
void studywin::CmToolsQuiz(){
	int items=qdt->GetItemsInContainer();
	int right=0,wrong=0,percent=0;
	TQuestionState qsta;
	char rw[256]="";
	//char temp[17]="";
	datint i(*qdt);
	if(items==0){
	MessageBox(string(HInstance,IDS_NOQUEST).c_str(),string(HInstance,IDS_NOK).c_str(),MB_OK);
	}
	else {
	while(i){
	Study_Data td = i++;
	qsta=askquestion(td);
	if(qsta.iscorrect) right++; else wrong++;
	if(!qsta.isok) goto quizend;
	};
	percent=(100*right)/(right+wrong);
	wsprintf(rw,string(HInstance,IDS_PERCENT).c_str(),right,wrong,percent);
	MessageBox(rw,string(HInstance,IDS_TOTAL).c_str(),MB_OK);
	quizend:};
};
void studywin::CmToolsTest(){
	//Create temporary copy of questions.
	unsigned int i;
	TQuestionState qsta;
	datint ir(*qdt);
	dat temdat(50,1,1);//Temporary Question list that can have questions safely detached.
	Study_Data td;
	if((qdt->GetItemsInContainer())==0){
	MessageBox(string(HInstance,IDS_NOQUEST).c_str(),string(HInstance,IDS_NOK).c_str(),MB_OK);
	} else {;
	while(ir){
	temdat.Add(ir++);
	};
	//Randomize Order of questions.
	i=1;
	while(i<=temdat.GetItemsInContainer()){
		td=temdat[i];
		temdat.Detach(i);
		temdat.AddAt(td,random(temdat.GetItemsInContainer())+1);
		i++;
	};
	//Go through the questions, detach correctly answered, ending when no questions left.
	testmstart:
	i=1;
	while(i<=temdat.GetItemsInContainer()){
		td = temdat[i];
		qsta=askquestion(td);
		if(!qsta.isok) break;
		if(qsta.iscorrect){
				temdat.Detach(i);
				i--;
		};
		i++;
	};
	if(temdat.GetItemsInContainer()!=0 && qsta.isok) goto testmstart;
	};//end if questions available
};

void studywin::CmAbout()
{
	TDialog(this,ABOUT).Execute();
};
void studywin::CmHelp()
{
	WinHelp("study.hlp",HELP_CONTENTS,0l);
};
void studywin::setcap(){
  char caption[300];
	strcpy(caption,AppName);
	if(!IsNewFile){ strcat(caption," - ");
	strcat(caption,FileData->FileName);};
	GetApplication()->GetMainWindow()->SetCaption(caption);
};

TQuestionState studywin::askquestion(Study_Data sd){
	TQuestionState ret;
	int qsta;
	if(IsReverseQA){
				string tstr=sd.question;
				sd.question=sd.answer;
				sd.answer=tstr;
	};
	strcpy(dt2.question,sd.question.c_str());
	strcpy(dt2.edit1,"\x00");
	strcpy(dt2.hint,sd.hint.c_str());
   HFONT hfont=dialogfont->GetHandle();
   /*int a;
   TFont* tfont=new TFont(hfont);
   LOGFONT lfont;
   tfont->GetObject(lfont);
   a=(int)(&lfont);
   */
	if(sd.ishint) qsta=(testdial(this,QUESTION,hfont).Execute());
	else qsta=(testdial(this,QUESTION2,hfont).Execute());
	if(qsta==IDOK) ret.isok=true; else ret.isok=false;
	Invalidate();
	Tcheckans ansret=sd.checkans(string(dt2.edit1));
	if (!(ansret.iscorrect)){
		::MessageBox(NULL,ansret.error.c_str(),string(HInstance,IDS_INCANS).c_str(),MB_OK);
		ret.iscorrect=false;
		} else
		{
			ret.iscorrect=true;
			if(sd.ccorrect){
          	if(sd.rightresponse.is_null()) MessageBox(string(HInstance,IDS_CONGRAD).c_str(),string(HInstance,IDS_CANS).c_str(),IDOK);
				else MessageBox(sd.rightresponse.c_str(),string(HInstance,IDS_CANS).c_str(),IDOK);
				};
		};
		return ret;
};

void studywin::CmReverseQA(){
				if(IsReverseQA==true){
												TMenu(GetApplication()->GetMainWindow()->GetMenu()).CheckMenuItem(CM_TOOLSREVERSE_QA,MF_UNCHECKED | MF_BYCOMMAND);
												IsReverseQA=false;
				}else{
												TMenu(GetApplication()->GetMainWindow()->GetMenu()).CheckMenuItem(CM_TOOLSREVERSE_QA,MF_CHECKED | MF_BYCOMMAND);
												IsReverseQA=true;
  				};
};
void studywin::CmFont(){
  	TChooseFontDialog::TData FontData;
   FontData.Flags = CF_EFFECTS | CF_FORCEFONTEXIST | CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;
  	FontData.FontType = SCREEN_FONTTYPE;
   dialogfont->GetObject(FontData.LogFont);
   if(TChooseFontDialog(this,FontData).Execute()==IDOK){
   	delete dialogfont;
		dialogfont=new TFont(&FontData.LogFont);
      IsFontModified=true;
   }
};
bool studywin::CanClose()
{
	if(IsDirty){switch(MessageBox(string(HInstance,IDS_DOSAVE).c_str(),string(HInstance,IDS_QUESTCHANGE).c_str(),
							 MB_YESNOCANCEL | MB_ICONQUESTION)) {
	case IDCANCEL:
			// Choosing Cancel means to abort the close -- return false.
	return false;

	case IDYES:
			//Choosing Yes means to save the question.
			CmFileSave();
	}
	};
	 return true;
};
void studywin::OpenFile(){
	ifstream is(FileData->FileName);

	if (!is)
	 MessageBox(string(HInstance,IDS_CANTOPEN).c_str(), string(HInstance,IDS_FILEERROR).c_str(), MB_OK | MB_ICONEXCLAMATION);
	else {
	 qdt->Flush();
	 unsigned  numquestions;
	 char tem43[2];
	 is >> numquestions;
	 is.getline(tem43,2);
    if(numquestions>0){
    //FILE_VERSION's 2 and later must start with a 0\n
    FILE_VERSION=1;
	 while (numquestions--) {
		Study_Data quest;
		is >> quest;
		qdt->Add(quest);
		}
   } else {//if numquestions<=0
		string tempstring;
      getline(is,tempstring);
      if(tempstring!=string("Study File")){
     	MessageBox("Unable to read this file version","Error",MB_OK);
      } else {
      is>>FILE_VERSION;
		getline(is,tempstring);
      while(tempstring!=string("EndOptions")){
		if(tempstring.substr(0,5)==string("Font=")){
			tempstring=tempstring.substr(5);
         LOGFONT tempfont;
      	//extract font options Yes, I know fread would be shorter
         tempfont.lfHeight=getfirstint(&tempstring);
         tempfont.lfWidth=getfirstint(&tempstring);
         tempfont.lfEscapement=getfirstint(&tempstring);
         tempfont.lfOrientation=getfirstint(&tempstring);
         tempfont.lfWeight=getfirstint(&tempstring);
         tempfont.lfItalic=getfirstint(&tempstring);
         tempfont.lfUnderline=getfirstint(&tempstring);
         tempfont.lfStrikeOut=getfirstint(&tempstring);
         tempfont.lfCharSet=getfirstint(&tempstring);
         tempfont.lfOutPrecision=getfirstint(&tempstring);
         tempfont.lfClipPrecision=getfirstint(&tempstring);
         tempfont.lfQuality=getfirstint(&tempstring);
         tempfont.lfPitchAndFamily=getfirstint(&tempstring);
         strcpy(tempfont.lfFaceName,(strip(tempstring,string::Leading)).c_str());
			delete dialogfont;
			dialogfont=new TFont(&tempfont);
			IsFontModified=true;
      };
      //process option string (none supported yet)
		getline(is,tempstring);
		};
	 	is >> numquestions;//Read the REAL number of questions
	 	while (numquestions--) {
			Study_Data quest;
			is >> quest;
			qdt->Add(quest);
		}
      }; //2cd line = "Study File"
   };
 	};//end if(!is)
	IsNewFile = false;
	IsDirty = false;
};
void studywin::SaveFile(){
	ofstream os(FileData->FileName);
  	datint  i(*qdt);
	if (!os)
	 MessageBox(string(HInstance,IDS_CANTSAVE).c_str(), string(HInstance,IDS_FILEERROR).c_str(), MB_OK | MB_ICONEXCLAMATION);
	else {
   switch(FileData->FilterIndex){
   case 1:
   	FILE_VERSION=1;
	 os << qdt->GetItemsInContainer() << '\n';
	 while (i)
		os << i++;
	break;
   case 2:
   	FILE_VERSION=2;
      os<<"0\n"<<"Study File"<<endl<<FILE_VERSION<<endl;
		if(IsFontModified){
      	LOGFONT tempfont;
      	dialogfont->GetObject(tempfont);
      	os<<"Font="<<tempfont.lfHeight<<' '<<tempfont.lfWidth<<' ';
         os<<tempfont.lfEscapement<<' '<<tempfont.lfOrientation<<' ';
         os<<tempfont.lfWeight<<' '<<(long)tempfont.lfItalic<<' ';
         os<<(long)tempfont.lfUnderline<<' '<<(long)tempfont.lfStrikeOut<<' ';
         os<<(long)tempfont.lfCharSet<<' '<<(long)tempfont.lfOutPrecision<<' ';
         os<<(long)tempfont.lfClipPrecision<<' '<<(long)tempfont.lfQuality<<' ';
         os<<(long)tempfont.lfPitchAndFamily<<' '<<tempfont.lfFaceName<<endl;
      };
      //Insert other option words
      os<<"EndOptions"<<endl;
      os << qdt->GetItemsInContainer() << endl;
	 	while (i)
			os << i++;
      break;
   };
	 IsNewFile = false;
	 IsDirty = false;
	}
};

//The application class
class study : public TApplication
{
	public:
		study() : TApplication() {}
		void CmFileExit();
		void InitMainWindow()
			{
				::HInstance=HInstance;
				SetMainWindow(new TFrameWindow(0,AppName,new studywin));
				GetMainWindow()->AssignMenu(MAINMENU);
				GetMainWindow()->SetIcon(this,DESK);
				EnableBWCC();
				char caption[300];
				strcpy(caption,AppName);
				if(argc>1){ strcat(caption," - ");
				strcat(caption,argv);};
				GetMainWindow()->SetCaption(caption);
			}
		DECLARE_RESPONSE_TABLE(study);
};

DEFINE_RESPONSE_TABLE1(study, TApplication)
	EV_COMMAND(CM_FILEEXIT, CmFileExit),
END_RESPONSE_TABLE;
void study::CmFileExit(){
		GetMainWindow()->CloseWindow();
};

int
OwlMain(int targc,char* targv[])
{
	if(targc>1) strcpy(argv,targv[1]);
	argc=targc;
	return study().Run();
}
ostream& operator <<(ostream& os,const Study_Data& data5)
{
	char buf[ANSWERLEN + HINTLEN + QUESTIONLEN+RIGHTLEN+WRONGLEN+20];
	ostrstream tstr(buf,sizeof buf );
   switch(FILE_VERSION){
   case 1:
	tstr <<'\t'<<data5.question<<'\t'<<data5.answer<<'\t'<<data5.hint<<'\t'<<data5.delimit;
	tstr <<data5.ishint<<' '<<data5.ccorrect<<' '<<data5.cwhite<<' '<<data5.cases<<' '<<data5.boolean<<ends;
   break;
	case 2:
	tstr <<data5.question<<'\t'<<data5.answer<<'\t'<<data5.hint<<'\t'<<data5.rightresponse<<'\t'<<data5.wrongresponse<<'\t'<<data5.delimit<<'\t';
	tstr <<data5.ishint<<'\t'<<data5.ccorrect<<'\t'<<data5.cwhite<<'\t'<<data5.cases<<'\t'<<data5.boolean<<endl<<ends;
	break;
   };
	return os << buf;
};
ifstream& operator >>(ifstream& is, Study_Data& data5)
{
	char junk,junk2[3];
	switch(FILE_VERSION){
   case 1:
	is.get(junk);//Remove extra tab
	getline(is,data5.question,'\t');
	data5.question=stringreplace(data5.question,"\n","\r\n");
	getline(is,data5.answer,'\t');
	data5.answer=stringreplace(data5.answer,"\n","\r\n");
	getline(is,data5.hint,'\t');
	data5.hint=stringreplace(data5.hint,"\n","\r\n");
	is.get(data5.delimit);
	is>>data5.ishint;
	is>>data5.ccorrect;
	is>>data5.cwhite;
	is>>data5.cases;
	is>>data5.boolean;
   break;
   case 2:
	is.getline(junk2,sizeof(junk2));
	getline(is,data5.question,'\t');
	data5.question=stringreplace(data5.question,"\n","\r\n");
	getline(is,data5.answer,'\t');
	data5.answer=stringreplace(data5.answer,"\n","\r\n");
	getline(is,data5.hint,'\t');
	data5.hint=stringreplace(data5.hint,"\n","\r\n");
	getline(is,data5.rightresponse,'\t');
	data5.rightresponse=stringreplace(data5.rightresponse,"\n","\r\n");
	getline(is,data5.wrongresponse,'\t');
	data5.wrongresponse=stringreplace(data5.wrongresponse,"\n","\r\n");
	is.get(data5.delimit);
   is.getline(junk2,sizeof(junk2),'\t');
	is>>data5.ishint;
	is>>data5.ccorrect;
	is>>data5.cwhite;
	is>>data5.cases;
	is>>data5.boolean;
	break;
   };
	return is;
};
